// wzAIBoard.cpp - Board for AI
// Copyright (C) 2006-2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "wzAIBoard.h"
#include "wzBoundObserver.h"
#include "wzFieldObserver.h"


//////////////////////////////////////
wzAIBoard::wzAIBoard( const wzBoardBase& other )
  : wzBoardBase( other ),
    m_pBoundObserver( new wzBoundObserver() ),
    m_pFieldObserver( new wzFieldObserver() )
{
    Register( m_pBoundObserver );
    Register( m_pFieldObserver );
}

///////////////////////
wzAIBoard::~wzAIBoard()
{
    delete m_pBoundObserver;
    delete m_pFieldObserver;
}

//////////////////////////////////
wzBound wzAIBoard::GetBound() const
{ 
    return m_pBoundObserver->GetBound();
}

////////////////////////////////////////////
const wzBitBoard& wzAIBoard::GetFields() const
{
    return m_pFieldObserver->GetFields();
}
