// wzAIBoard.h - Board for AI
// Copyright (C) 2006-2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __WZ_AI_BOARD_H__
#define __WZ_AI_BOARD_H__

#include "wzBoardBase.h"
#include "wzBound.h"

class wzBoundObserver;
class wzFieldObserver;


////////////////////
// Board for AI engine.
///////////////////////////////////////////////////////////////
class wzAIBoard : public wzBoardBase
{
public:
    wzAIBoard( const wzBoardBase& other );
    virtual ~wzAIBoard();

    // inquiries
    wzBound            GetBound()  const;
    const wzBitBoard&  GetFields() const;

private:
    wzBoundObserver*  m_pBoundObserver;
    wzFieldObserver*  m_pFieldObserver;

private:
    wzAIBoard();
    wzAIBoard( const wzAIBoard& );
    wzAIBoard& operator=( const wzAIBoard& );
};

#endif
