// wzAIPlayer.cpp - AI player, subclass of wzPlayer
// Copyright (C) 2006  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "wzAIPlayer.h"
#include "wzAIEngine.h"
#include "wzGame.h"
#include "wzBoard.h"


wzAIPlayer::wzAIPlayer( wzSTONE stone, short Level )
  : wzPlayer( stone ),
    m_pAIEngine( new wzAIEngine( Level ) )
{
}

wzAIPlayer::~wzAIPlayer() 
{
    delete m_pAIEngine;
}

bool wzAIPlayer::MakeAMove( wzMove& move )
{
    move.Stone = m_Stone;
    m_pAIEngine->BestMove( m_pGame, m_pBoard, move );

    return true;
}
