// wzBoardView.h - Board view base.
// Copyright (C) 2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __WZ_BOARD_VIEW_H__
#define __WZ_BOARD_VIEW_H__

#include "wzBoardObserver.h"

class wzBoard;


///////////////////
// Board visualization base
//////////////////////////////////////////////////////////////
class wzBoardView : public wzBoardObserver
{
public:
    wzBoardView()  {}
    virtual ~wzBoardView()  {}

    virtual void  UpdateView()  {}
    virtual bool  WaitForInput( short& x, short& y )  { return false; }
    virtual void  NotifyInput()  {}

    // overrides in wzBoardObserver
    virtual void  Init ( wzBoardBase* pBoardBase );
    virtual void  Set  ( const wzMove& m )  { UpdateView(); }
    virtual void  Reset( const wzMove& m )  { UpdateView(); }
    virtual void  Clean()                   { UpdateView(); }

protected:
    wzBoard*  m_pBoard;

private:
    wzBoardView( const wzBoardView& );
    wzBoardView& operator=( const wzBoardView& );
};

#endif
