// wzFieldObserver.cpp - Track fields that are affected by stones on the board.
// Copyright (C) 2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "wzFieldObserver.h"
#include "wzBoardBase.h"


/////////////////////////////////////
void wzFieldObserver::Init( wzBoardBase* pBoardBase )
{
    Clean(); 
    m_Fields.Clean();
    for( short y = 0; y < wzDimension; y++ )
    {
        for( short x = 0; x < wzDimension; x++ )
        {
            if( !pBoardBase->IsEmpty( x, y ) )
            {
                m_Fields += m_StarPattern.GetPattern( x, y );
            }
        }
    }
    // save the initial fields
    m_Stack.push( m_Fields );
}

/////////////////////////////////////
void wzFieldObserver::Set( const wzMove& m )
{
    m_Fields += m_StarPattern.GetPattern( m.X, m.Y );
    m_Stack.push( m_Fields );
}

/////////////////////////////////////
void wzFieldObserver::Reset( const wzMove& m )
{
    m_Stack.pop();
    m_Fields = m_Stack.top();
}
