// wzGameRunner.h - The game runner class
// Copyright (C) 2006  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __WZ_GAME_RUNNER_H__
#define __WZ_GAME_RUNNER_H__

#include "wzDefs.h"

class wzGame;
class wzBoard;
class wzPlayer;


/////////////////////////////////
class wzGameRunner
{
public:
    wzGameRunner( wzGame* pGame );
    virtual ~wzGameRunner();

    void  Run();
    void  SetBlack( wzPlayer* pPlayer );
    void  SetWhite( wzPlayer* pPlayer );
    void  CurrentPlayer( wzSTONE color );

private:
    void  GameEnded( wzSTONE winner );
    void  Revert();
    void  DoSave();
    void  DoSaveAs();
    void  SwitchPlayer();

private:
    wzGame*    m_pGame;
    wzBoard*   m_pBoard;
    wzPlayer*  m_pPlayers[2];
    short      m_CurrentPlayer;
};


/////////////////////////////////////////////////////
inline void wzGameRunner::CurrentPlayer( wzSTONE color  )
{ 
    m_CurrentPlayer = (color == wzBLACK)? 0 : 1;
}

/////////////////////////////////////////////////////
inline void wzGameRunner::SwitchPlayer()
{ 
    m_CurrentPlayer = (m_CurrentPlayer == 0)? 1 : 0;
}

#endif
