// wzOptions.h - Game options
// Copyright (C) 2006-2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __WZ_OPTIONS_H__
#define __WZ_OPTIONS_H__

#include "wzDefs.h"

#include <string>
#include <iosfwd>


/////////////////////////
// game options
/////////////////////////////////////////////////////////////////
class wzOptions
{
public:
    wzOptions();
    virtual ~wzOptions() {}

    wzOptions& operator=( const wzOptions& other );

    bool  Valid() const;
    bool  HasHumanPlayer() const;

    void  SetDefault();
    void  CopyBlack( const wzOptions& other );
    void  CopyWhite( const wzOptions& other );

    static bool  Valid( const wzUInt8& code, const std::string& name );
    static std::string  ComputerPlayerName( const wzUInt8& level );

    friend std::ifstream&  operator>>( std::ifstream&, wzOptions& );
    friend std::ofstream&  operator<<( std::ofstream&, const wzOptions& );

public:
    // player code
    wzUInt8      m_BlackStone;
    wzUInt8      m_WhiteStone;

    // player name or LuaScript name
    std::string  m_BlackName;
    std::string  m_WhiteName;
};

#endif
