// wzPlayer.h - Player base
// Copyright (C) 2006-2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __WZ_PLAYER_H__
#define __WZ_PLAYER_H__

#include "wzDefs.h"

class wzGame;
class wzBoard;
class wzMove;

///////////////////////
// Player base
////////////////////////////////////////////////////
class wzPlayer 
{
public:
    wzPlayer( wzSTONE stone ) : m_Stone( stone ) {}
    virtual ~wzPlayer() {}

    virtual void  Init() {}
    virtual void  Set( wzGame* pGame, wzBoard* pBoard );
    virtual bool  MakeAMove( wzMove& move );

    void     SetStone( wzSTONE stone )  { m_Stone = stone; }
    wzSTONE  GetStone() const           { return m_Stone; }

protected:
    wzGame*   m_pGame;
    wzBoard*  m_pBoard;
    wzSTONE   m_Stone;
};


inline void wzPlayer::Set( wzGame* pGame, wzBoard* pBoard ) 
{
    m_pGame  = pGame;
    m_pBoard = pBoard;
}

#endif
