// wzReferee.h - Referee identifies winner of a board position
// Copyright (C) 2006  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __WZ_REFEREE_H__
#define __WZ_REFEREE_H__

#include "wzPattern.h"
#include "wzMove.h"
#include "wzBound.h"

class wzBoardBase;
class wzBoard;


class wzReferee
{
public:
    wzReferee() {} 
    virtual ~wzReferee() {} 

    wzSTONE  Winner( wzBoard& b );
    wzSTONE  Winner( const wzBoardBase& b, const wzMove& LastMove );
    wzSTONE  Winner( const wzBoardBase& b, const wzMove& LastMove, wzBound& WinningRow );

private:
    bool  Winning( const wzBitBoard& bb, wzPattern& pattern, 
                   const wzMove& LastMove, wzBound& WinningRow );

    // winning patterns
    wzHorizontal5  m_Horizontal5;
    wzVertical5    m_Vertical5;
    wzDiagonal5F   m_Diagonal5F;
    wzDiagonal5B   m_Diagonal5B;
};

#endif
