// wzVersion.cpp - Tick5 version numbers
// Copyright (C) 2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "wzVersion.h"
#include <config.h>

#include <fstream>
using namespace std;


///////////////////////////////////
wzVersion::wzVersion()
  : m_Version( std::string(PACKAGE_VERSION) ), 
    m_Begin( 0 ), m_End( 0 )
{
    m_Major = Next();
    m_Minor = Next();
    m_Micro = Next();
}

///////////////////////////////////
wzVersion::wzVersion( const char* version )
  : m_Version( std::string(version) ), 
    m_Begin( 0 ), m_End( 0 )
{
    m_Major = Next();
    m_Minor = Next();
    m_Micro = Next();
}

///////////////////////////////////
wzUInt8 wzVersion::Next()
{
    static const char dot = '.';

    if( m_End == std::string::npos )
        return static_cast<wzUInt8>( 0 );

    m_Begin = m_Version.find_first_not_of( dot, m_End );
    if( m_Begin == std::string::npos )
        return static_cast<wzUInt8>( 0 );

    m_End = m_Version.find_first_of( dot, m_Begin );
    int num = atoi( m_Version.substr( m_Begin, m_End-m_Begin ).c_str() );

    return static_cast<wzUInt8>( num );
}

//////////////////////////////////////////////////
ofstream& operator<<( ofstream& oFile, const wzVersion& version )
{
    oFile << version.m_Major;
    oFile << version.m_Minor;
    oFile << version.m_Micro;

    return oFile;
}
