// wzVersion.h - Tick5 version numbers
// Copyright (C) 2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __WZ_VERSION_H__
#define __WZ_VERSION_H__

#include "wzDefs.h"

#include <string>
#include <iosfwd>


////////////////////////////////
// Tick5 version
///////////////////////////////////////////////
class wzVersion
{
public:
    wzVersion();
    wzVersion( const char* version );
    ~wzVersion() {}

    wzUInt8  Major()  { return m_Major; }
    wzUInt8  Minor()  { return m_Minor; }
    wzUInt8  Micro()  { return m_Micro; }

    friend std::ofstream&  operator<<( std::ofstream&, const wzVersion& );

private:
    wzUInt8  Next();

private:
    std::string             m_Version;
    std::string::size_type  m_Begin;
    std::string::size_type  m_End;

    wzUInt8  m_Major;
    wzUInt8  m_Minor;
    wzUInt8  m_Micro;
};

#endif
