// wzTUIApp.h - Textual UI app
// Copyright (C) 2006-2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __WZ_TUI_APP_H__
#define __WZ_TUI_APP_H__


#include <wzDefs.h>
#include "wzTUIGame.h"


////////////////////
// text UI app
///////////////////////////////
class wzTUIApp
{
public:
    wzTUIApp()          {}
    virtual ~wzTUIApp() {}

    void   Run();

private:
    void   NewGame();
    void   OpenGame();
    void   SaveGame();
    short  SelectGame();
    short  SelectPlayer( const char* name );
    short  SelectLevel();
    bool   SelectOptions( wzOptions& options, wzSTONE stone );
    bool   Continue();

private:
    wzTUIGame  m_Game;

    enum { NEW_GAME = 1, OPEN_GAME };
    enum { COMPUTER_PLAYER = 1, HUMAN_PLAYER, LUA_AI_PLAYER };
};

#endif
