// wzTUIBoardView.h - Board visualization for TUI app.
// Copyright (C) 2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __WZ_TUI_BOARD_VIEW_H__
#define __WZ_TUI_BOARD_VIEW_H__

#include <wzBoardView.h>
class wzGame;


///////////////////
// Board visualization for TUI app
//////////////////////////////////////////////////////////////
class wzTUIBoardView : public wzBoardView
{
public:
    wzTUIBoardView( wzGame* pGame ) : wzBoardView() { m_pGame = pGame; }
    virtual ~wzTUIBoardView() {}

    virtual void  UpdateView();
    virtual bool  WaitForInput( short& x, short& y);

private:
    void  DrawBoard();
    void  DrawClocks();
    void  HilightLastMove();
    void  HilightWinningRow();
    void  HilightHint();

    bool  Select();

private:
    wzGame*  m_pGame;

private:
    wzTUIBoardView( const wzTUIBoardView& );
    wzTUIBoardView& operator=( const wzTUIBoardView& );
};

#endif
