// wzTUIGame.h - Game for textual UI, subclass of wzGame
// Copyright (C) 2006-2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __WZ_TUI_GAME_H__
#define __WZ_TUI_GAME_H__

#include "wzGame.h"

class wzBoardView;


//////////////////////
// text UI game
////////////////////////////////////////////
class wzTUIGame : public wzGame
{
public:
    wzTUIGame();
    virtual ~wzTUIGame();

    static void  CtrlCHandler( int );

protected:
    // overrides
    virtual void  BlackWins();
    virtual void  WhiteWins();
    virtual void  GameDraw();
    virtual void  GameStopped();
    virtual void  StartMove( short iPlayer );
    virtual void  GameFileError( const char* msg );

    virtual std::string  PromptFile( bool bForOpen );

private:
    wzBoardView*  m_pBoardView;

    static wzGame*  m_pThisGame;
};

#endif
