// wzAppConfig.h - App configuration using wxFileConfig
// Copyright (C) 2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __WZ_APP_CONFIG_H__
#define __WZ_APP_CONFIG_H__

class wxFileConfig;
class wzOptions;


///////////////////////////
class wzAppConfig
{
public:
    wzAppConfig();
    virtual ~wzAppConfig();

    void ReadFrameConfig ( wxPoint& position, bool& bBigview );
    void WriteFrameConfig( const wxPoint& position, const bool& bBigview );

    void ReadGameOptions ( wzOptions& options );
    void WriteGameOptions( const wzOptions& options );

    void ReadLuaOutputConfig ( wxPoint& position, wxSize& size );
    void WriteLuaOutputConfig( const wxPoint& position, const wxSize& size );

    void ReadTickSoundConfig ( bool& bSoundOn );
    void WriteTickSoundConfig( const bool& bSoundOn );

private:
    wxFileConfig*  m_pConfigFile;

private:
    static const wxString  m_FrameXPosition;
    static const wxString  m_FrameYPosition;
    static const wxString  m_FrameBigView;

    static const wxString  m_OptionBlackCode;
    static const wxString  m_OptionWhiteCode;
    static const wxString  m_OptionBlackName;
    static const wxString  m_OptionWhiteName;

    static const wxString  m_LuaOutputXPosition;
    static const wxString  m_LuaOutputYPosition;
    static const wxString  m_LuaOutputWidth;
    static const wxString  m_LuaOutputHeight;

    static const wxString  m_TickSoundOn;
};

#endif
