// wzFilePrompter.h - Prompt game file
// Copyright (C) 2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __WZ_FILE_PROMPTER_H__
#define __WZ_FILE_PROMPTER_H__

#include <string>

class wzFilePromptEvent;


/////////////////////////////////
// wzFilePrompter: Helps wzGame::FilePrompt() work properly on GTK.
//
// wxFileDialog cannot be invoked directly from a worker thread
// on GTK, while there's no problem to do so on MSW.
/////////////////////////////////////////////////////////////////
class wzFilePrompter : public wxEvtHandler
{
public:
    wzFilePrompter();
    virtual ~wzFilePrompter();

    std::string  PromptFile( bool ForOpen );

    void  OnFilePrompt( wzFilePromptEvent& event );

private:
    void  PopFileDialog    ( bool ForOpen );
    void  TriggerFileDialog( bool ForOpen );
    void  WaitFilePrompt();
    void  FinishFilePrompt();

private:
    wxMutex*       m_pMutex;
    wxCondition*   m_pCondition; 
    std::string    m_FileName;
    
    DECLARE_EVENT_TABLE()
};

#endif

