// wzGUILuaVM.h - C++ wrapper of lua_State for GUI app
// Copyright (C) 2006  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __WZ_TUI_LUA_VM_H__
#define __WZ_TUI_LUA_VM_H__

#include <wzLuaVM.h>


///////////////////////////////
class wzGUILuaVM : public wzLuaVM
{
public:
    wzGUILuaVM( wxEvtHandler* pEvtHandler, short LuaLibs = wzLuaVM::ALL_LIBS );
    virtual ~wzGUILuaVM() {}

private:
    void  RegMethods();
    void  PostEvent( wxEvent& event );

    wxEvtHandler*  m_pEvtHandler;

private:
    static void  PostMsg( lua_State* pLS, const wxString& msg );

    // replace Lua functions
    static int  LuaAlert( lua_State* pLS );
    static int  LuaPrint( lua_State* pLS );
    static int  LuaIOHandler( lua_State* pLS );

    static const char      m_ClassName[];     // name of this class
    static const luaL_reg  m_LuaIOMethods[];
};

#endif
