// wzTickSound.h - Tick sound.
// Copyright (C) 2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __WZ_TICK_SOUND_H__
#define __WZ_TICK_SOUND_H__

#include <wzBoardObserver.h>
#include <sys/time.h>

class wxSound;


///////////////////
// Play sound when a move is made.
///////////////////////////////////////////////////////////////////
class wzTickSound : public wzBoardObserver
{
public:
    wzTickSound();
    virtual ~wzTickSound();

    void  Enable( bool bEnable );

    // overrides
    virtual void  Init ( wzBoardBase*  )  {}
    virtual void  Set  ( const wzMove& );
    virtual void  Reset( const wzMove& )  {}
    virtual void  Clean()                 {}

private:
    bool  IsOK();

private:
    wxSound*  m_pSound;
    bool      m_Enabled;
    bool      m_Loaded;
    timeval   m_Previous;

private:
    wzTickSound( const wzTickSound& );
    wzTickSound& operator=( const wzTickSound& );
};


// not thread-safe, but not worth to sync it
inline void wzTickSound::Enable( bool bEnable )
{
    m_Enabled = m_Loaded && bEnable;
}

#endif
