// wzGameFileTest.h - Unit test for wzGameFile
// Copyright (C) 2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __WZ_GAME_FILE_TEST_H__
#define __WZ_GAME_FILE_TEST_H__

#include <TestCase.h>
#include <fstream>

class wzGameFile;
class wzGame;


class wzGameFileTest : public TestCase
{
public:
    wzGameFileTest( std::string name ) : TestCase( name ) {}
    virtual ~wzGameFileTest() {}

    static Test*  suite();

    virtual void  setUp();
    virtual void  tearDown();

    void testWrite();
    void testWriteMoves();

    void testRead();
    void testReadWrongID();
    void testReadWrongOptions();
    void testApplyMoves();

    void testSaveOpen();
    void testSaveAs();

    void testIsSaved();

private:
    wzGameFile*    m_pGameFile;
    wzGame*        m_pGame;
};

#endif
