// wzTestApp.cpp - App for unit test
// Copyright (C) 2006-2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include <wxTestRunner.h>

#include "wzTestApp.h"
#include "wzBitBoardTest.h"
#include "wzPatternIteratorTest.h"
#include "wzBoundObserverTest.h"
#include "wzMoveObserverTest.h"
#include "wzFieldObserverTest.h"
#include "wzBoardBaseTest.h"
#include "wzBoardTest.h"
#include "wzAIBoardTest.h"
#include "wzRefereeTest.h"
#include "wzEvaluatorTest.h"
#include "wzVersionTest.h"
#include "wzGameFileTest.h"
#include "wzClockTest.h"
//#include "wzAIEngineTest.h"


IMPLEMENT_APP( wzTestApp )


bool wzTestApp::OnInit()
{
    wxTestRunner  runner;
	
    runner.addTest( wzBitBoardTest::suite() );
    runner.addTest( wzPatternIteratorTest::suite() );
    runner.addTest( wzBoundObserverTest::suite() );
    runner.addTest( wzMoveObserverTest::suite() );
    runner.addTest( wzFieldObserverTest::suite() );
    runner.addTest( wzBoardBaseTest::suite() );
    runner.addTest( wzBoardTest::suite() );
    runner.addTest( wzAIBoardTest::suite() );
    runner.addTest( wzRefereeTest::suite() );
    runner.addTest( wzEvaluatorTest::suite() );
    runner.addTest( wzVersionTest::suite() );
    runner.addTest( wzGameFileTest::suite() );
    runner.addTest( wzClockTest::suite() );
    //runner.addTest( wzAIEngineTest::suite() );

    runner.run();
	
    return FALSE;
}
