// wzVersionTest.cpp - Unit test for wzVersion
// Copyright (C) 2007  XMartin Yao
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include <TestSuite.h>
#include <TestCaller.h>

#include "wzVersionTest.h"
#include <wzVersion.h>


void wzVersionTest::testVersion()
{
    wzVersion v( "3.14.159" );
    assert( v.Major() == 3 );
    assert( v.Minor() == 14 );
    assert( v.Micro() == 159 );

    wzVersion v2( "3.14.159.26" );
    assert( v2.Major() == 3 );
    assert( v2.Minor() == 14 );
    assert( v2.Micro() == 159 );

    wzVersion v3( "1.41" );
    assert( v3.Major() == 1 );
    assert( v3.Minor() == 41 );
    assert( v3.Micro() == 0 );

    wzVersion v4( "0" );
    assert( v4.Major() == 0 );
    assert( v4.Minor() == 0 );
    assert( v3.Micro() == 0 );
}


Test* wzVersionTest::suite()
{
    TestSuite *suite = new TestSuite( "wzVersionTest" );

    suite->addTest( CU_SUIT_TEST( wzVersionTest, testVersion ) );

    return suite;
}
